#include <SPI.h>
#include <Adafruit_GFX.h>
#include <SdFat.h>
#include <Adafruit_ImageReader.h>
#include "Adafruit_ST7796S_kbv.h"

int cs = 0;
Adafruit_ST7796S_kbv tft(cs, 29, 28);
SdFat SD;
Adafruit_ImageReader reader(SD);

bool sensors[4] = {0, 0, 0, 0};
int ind = 0;

#define BLACK   0x0000
#define BLUE    0x001F
#define RED     0xF800
#define GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0
#define WHITE   0xFFFF
#define GREY    0x8410
#define ORANGE  0xE880

void setup()
{
  Serial.begin(9600);
  Wire.begin();
  tft.begin();
  tft.setRotation(1);
  tft.fillScreen(BLACK);
  delay(100);
  if (!SD.begin(1)) {
    Serial.println("SD card initialization failed!");
    return;
  }
  Serial.println("SD card initialized.");
  
  reader.drawBMP("test.bmp", tft, 0, 0);
  delay(500);
}

void loop()
{
  Wire.requestFrom(9, 4);
  for (int i = 0; i < 4; i++) {
    int receiveVal = Wire.read();
    receiveVal = (receiveVal + 15) % 255;
    Serial.print(i); Serial.print(": ");
    Serial.println(receiveVal);
    if ((receiveVal >= 60 && receiveVal <= 220 && (i % 2 == 1)) || (receiveVal > 50 && i == 0) || ((receiveVal > 150) && i == 2)) {
      if (sensors[i] == 0) ind = 0;
      sensors[i] = 1;
    } else sensors[i] = 0;
  }
  for (int i = 0; i < 4; i++) {
    if (sensors[i] == 1) {
      ind = ind % 5 + 1;
      char fileName[10];
      char sensorLetter = 'A' + i;
      sprintf(fileName, "%c%d.bmp", sensorLetter, ind);
      Serial.print("Loading image: ");
      Serial.println(fileName);
      reader.drawBMP(fileName, tft, 0, 0);
    }
    if (ind == 1) {
      delay(500);
    } else {
      delay(500);
    }
    continue;
  }
  //if (sensors[0] == sensors[1] == sensors[2] == sensors[3] == 0) reader.drawBMP("test.bmp", tft, 0, 0);
}
